function comaz_hvocig3Dbut(xs,ys,zs,yr,thetas,azims,thetar)

%(xs,ys,zs) coordinates of the end point of source   ray FOR HOCIG !!!
%(xr,yr,zr) coordinates of the end point of receiver ray FOR HICIG !!!
%	    In the ComAz case, xs=xr and zs=zr
%	    ATTENTION: I have mixed up x and y axis
%	    That is why we have xs=xr and not ys=yr
%	    ATTENTION: here I compute HOCIG only.
%	    HOCIG (z=cst) is computed. Hence there is no 
%	    So or Ro anymore, but only Sz and Rz.
%thetas,azims: dipping and azimuth of source ray at endind point
%thetar,azimr: dipping and azimuth of receiver ray at endind point
%	    In the ComAz case, 3 of them are independant
%	    We choose azimr to be expressed with the others

xr=xs;
zr=zs;

%examples of values (1000,1000,1000,1500,900,20,30,60,80)
%examples of values (1000,1000,1000,1500,900,25,40,55,70)

%values for ComAz   comaz_hvocig3Dbut(1000,1000,1000,1500,125,150,155)

nbpts = 20 ;    %number of points to draw lines

%conversion in radian of alpha and gamma angles
thetas = thetas * pi / 180 ;
thetar = thetar * pi / 180 ;
azims  = azims  * pi / 180 ;
azimr  = - acos( cos(azims) * tan(thetar) / tan(thetas) )  ;

%<<<<==== COMPUTING SOURCE AND RECEIVER RAY ====>>>>

%---- ray vectors for source, receiver, normal
vecs = [ -cos(thetas)*cos(azims)...
          cos(thetas)*sin(azims)...
          sin(thetas) ] ;
vecr = [ -cos(thetar)*cos(azimr)...
          cos(thetar)*sin(azimr)...
          sin(thetar) ] ;

vecn = vecs + vecr ; 		%normal ray direction
vecn = vecn / norm(vecn) ; 	%normalization

%In the COMAZ case, source and receiver ray cross in P
%Coordinates of P:
mu     =  vecs(1)*(ys-yr) / ...
         (vecr(1)*vecs(2) - vecs(1)*vecr(2));
xp  = xr - vecr(1) * mu ;
yp  = yr - vecr(2) * mu ;
zp  = zr - vecr(3) * mu ;

%--- Window
xmax=max(xr,xs)+100;
ymax=max(yr,ys)+100;
xmin=min(xr,xs)-100;
ymin=min(yr,ys)-100;

%--- Computation of the plane orthogonal to normal and containing S
x=linspace(xp-100,xp+100,5);
y=linspace(yp-100,yp+100,5);
[plane_x,plane_y]=meshgrid(x,y);
 plane_z = zp - (vecn(1)*(plane_x-xp)+...
                 vecn(2)*(plane_y-yp) )/vecn(3);

%---- coordinates of some points
xo = ( xs + xr ) / 2 ; % middle of HOCIG segment: Iz
yo = ( ys + yr ) / 2 ; % middle of HOCIG segment: Iz
zo = ( zs + zr ) / 2 ; % middle of HOCIG segment: Iz

%---- computing the rays and the interface
dots = linspace(0,550,nbpts) ;
%--- source ray
line_source_x    = xp + vecs(1) * dots ;
line_source_y    = yp + vecs(2) * dots ;
line_source_z    = zp + vecs(3) * dots ;
%--- receiver ray
line_receiver_x  = xp + vecr(1) * dots ;
line_receiver_y  = yp + vecr(2) * dots ;
line_receiver_z  = zp + vecr(3) * dots ;
%--- normal ray
line_normal_x    = xp + vecn(1) * dots ;
line_normal_y    = yp + vecn(2) * dots ;
line_normal_z    = zp + vecn(3) * dots ;
%--- interface
line_interface_x = xs + linspace(0,xr-xs,nbpts) ;
line_interface_y = ys + linspace(0,yr-ys,nbpts) ;
line_interface_z = zs + linspace(0,zr-zs,nbpts) ;

%<<<<==== COMPUTING SOURCE AND RECEIVER POSITIONS ====>>>>
%Amount of shift
d1 = (xp-xs)^2+(yp-ys)^2+(yp-ys)^2;
d1 = sqrt(d1);
d2 = (xp-xr)^2+(yp-yr)^2+(yp-yr)^2;
d2 = sqrt(d2);
d  = .5 * (d1+d2);
%source position
xxs = xp + d * vecs(1);
yys = yp + d * vecs(2);
zzs = zp + d * vecs(3);
%Receiver position
xxr = xp + d * vecr(1);
yyr = yp + d * vecr(2);
zzr = zp + d * vecr(3);
%segment SR 
sr_x = linspace(xxs,xxr,20);
sr_y = linspace(yys,yyr,20);
sr_z = linspace(zzs,zzr,20);

%<<<<==== COMPUTING ORTHOGONAL PLANES TO HOCIG ====>>>>
                
%--- Computation of the plane orthogonal to HOCIG
vec_z = [ xs-xr , ys-yr , 0 ];
vec_z = vec_z / norm(vec_z);
x=linspace( 850,1100,10);
z=linspace( 900,1200,10);
[plane_z_x,plane_z_z]=meshgrid(x,z);
 plane_z_y = yo + (-vec_z(1)*(plane_z_x-xo)+...
                    vec_z(3)*(plane_z_z-zo) )/vec_z(2);
%--- Coeff planez
coef_plane_z = [vec_z(1),     vec_z(2),     vec_z(3),...
		vec_z(1)*xo + vec_z(2)*yo + vec_z(3)*zs];

%--- intersection of the normal with plane orthogonal to plane x
num = (xo-xp)*vec_z(1) + (yo-yp)*vec_z(2) + (zo-zp) *vec_z(3) ;
den = vec_z(1)* vecn(1) + vec_z(2)* vecn(2) + vec_z(3)*vecn(3)  ;
k   = num / den ;
xg  = xp + k * vecn(1)  ;
yg  = yp + k * vecn(2)  ;
zg  = zp + k * vecn(3)  ;

%--- segment Iz (middle HOCIG) Igamma
izig_x = linspace(xo,xg,20);
izig_y = linspace(yo,yg,20);
izig_z = linspace(zo,zg,20);

%<<<<==== PLOTTING EVERYTHING ====>>>>

clf
%axis vis3d off
campos([3251.6 ,  3137.8 ,   4840.5])
shading interp
hold on
%--- given geometry of the problem
plot3(line_normal_x  ,line_normal_y  ,line_normal_z  ,'k-.') %normal
plot3(line_source_x  ,line_source_y  ,line_source_z  ,'r') %source ray
plot3(line_receiver_x,line_receiver_y,line_receiver_z,'b') %receiver ray
plot3(xp ,yp ,zp ,'kp')	%crossing point
plot3(xxs,yys,zzs,'r*') %So
plot3(xxr,yyr,zzr,'bv') %Ro
plot3(sr_x,sr_y,sr_z,'k') %interface line

%--- this stuff is for the HOCIG
plot3(xs,ys,zs,'r*') %Sz
plot3(xr,yr,zr,'bv') %Rz
plot3(xo,yo,zo,'ko') %Iz
plot3(line_interface_x,line_interface_y,line_interface_z,'g-.') %interface
surf(plane_x,plane_y,plane_z)

%mesh(plane_z_x,plane_z_y,plane_z_z) % plan ortho to [ Sz Rz ]
plot3(xg,yg,zg,'pk')
%plot3(izig_x,izig_y,izig_z,'k.')

%--- Display
axis equal
shading interp
grid
xlabel('y')
ylabel('x')
zlabel('z')
%title('Common Azimuth Case')
axis([800 xp+50 900 1600 zp-50 zg+50])
